/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

#ifndef _3DMath_h_
#define _3DMath_h_

#include "mygl.h"
#include <assert.h>

#define WANT_MEMCPY
#include "porting.h"

//#include "porting.h"

typedef GLfloat GLMatrix[4][4];
typedef GLfloat GLVector3[3];

inline void MatrixCopy(GLMatrix *MD, GLMatrix *MS)  { assert(MS!=MD); memcpy(MD,MS,sizeof(GLMatrix)); };

void MatrixLoadIdentity(GLMatrix *M);
void MatrixMoveForward(GLMatrix *M, GLfloat S);
void MatrixMoveBackward(GLMatrix *M, GLfloat S);
void MatrixTranspose(GLMatrix *MD, GLMatrix *MS);

void MatrixMove(GLMatrix (*M), float Forward, float LR, float DU);
void MatrixRotate(GLMatrix *M, const GLfloat RotLR, const GLfloat RotDU, const GLfloat Rol);

#endif /* 3DMath */
