/* Modul CockpitMap - vykresleni mrizkove mapy v kokpitu
   Vytvoril Jaroslav Kadlec
   Datum    20.3.2001
*/


#include "SceneClasses.h";


//struktura pro seznam nesouci souradnice objektu s prepocitanymi vzhledem ke kamere
//s opravenymi osami tak, aby padly do souradneho systemu mapy
struct sMapObjInfo {
    float x,y,z;                 //souradnice
    float r,g,b;                 //rgb barva pro dany objekt
};


//----------------------------------------------------
// Systemove funkce, predavaji ukazatele, jsou volany
// pro potreby CockpitMap v SceneClasses a Cockpit
//----------------------------------------------------

//ulozi pro mapu ukazatele na seznam s pohybujicimi se objekty
void SetShortcut2SceneObjs(scMobile * mList, scStatic * sList);


//----------------------------------------------------
//Uzivatelske funkce pro obsluhu CockpitMap
//----------------------------------------------------

// vykresli mapu
int CockpitMapDraw();

// inicializuje mapu, instaluje displaylisty
int CockpitMapInit();

// zmena priblizeni v mape
int CockpitMapChangeScale(int cmscale);

// zmena velikosti mapy
int CockpitMapChangeSize(int newsize);

// zmena pozice mapy
int CockpitMapChangePos(int newx, int newy);

// zmena pruhlednosti mapy
int CockpitMapChangeTransparency();



