/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

#ifndef _InputDevices_h_
#define _InputDevices_h_


#include "setup.h"


#ifdef USE_SDL
#include "SDL_mouse.h"
#endif


int MouseInit(void);
void MouseDone(void);
int MouseAcquire(void);
void MouseUnacquire(void);
int MouseWindowCallback(void);
int MouseGetData(int &X, int &Y);


#ifdef USE_SDL
extern Uint8 *keystate;
inline int KeyPressed(const int key)  { return keystate[key]; };
#endif
#ifdef USE_GLUT
extern char KeyboardBuffer[256];
inline int KeyPressed(const char key)  { return (KeyboardBuffer[key] & 0x80); };
#endif

int KeyboardInit(void);
void KeyboardDone(void);
int KeyboardAcquire(void);
void KeyboardUnacquire(void);
int KeyboardUpdate(void);


#endif /* _Input_h_ */
