/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */


#include "SceneClasses.h"
#include "3DMath.h"

scMobile *ThisPlayer = NULL;

ViewersMatricesInfo ViewersMatrices;



void BillboardRender(GLfloat X, GLfloat Y, GLfloat Z, GLfloat A)
{
	GLfloat Rx,Ry,Rz;
	GLfloat Ux,Uy,Uz;
	Rx = ViewersMatrices.TransposedRotMatrix[0][0];
	Ry = ViewersMatrices.TransposedRotMatrix[0][1];
	Rz = ViewersMatrices.TransposedRotMatrix[0][2];
	Ux = ViewersMatrices.TransposedRotMatrix[1][0];
	Uy = ViewersMatrices.TransposedRotMatrix[1][1];
	Uz = ViewersMatrices.TransposedRotMatrix[1][2];

	glBegin(GL_TRIANGLE_FAN);
	glTexCoord2i(0,0);
	glVertex3f( X+((-Rx-Ux)*A), Y+((-Ry-Uy)*A), Z+((-Rz-Uz)*A));
	glTexCoord2i(1,0);
	glVertex3f( X+((+Rx-Ux)*A), Y+((+Ry-Uy)*A), Z+((+Rz-Uz)*A));
	glTexCoord2i(1,1);
	glVertex3f( X+((+Rx+Ux)*A), Y+((+Ry+Uy)*A), Z+((+Rz+Uz)*A));
	glTexCoord2i(0,1);
	glVertex3f( X+((-Rx+Ux)*A), Y+((-Ry+Uy)*A), Z+((-Rz+Uz)*A));
	glEnd();
}


void scMobile::TimeTick(const float DTime)
{
	Matrix[3][0] += Speed.x * DTime;
	Matrix[3][1] += Speed.y * DTime;
	Matrix[3][2] += Speed.z * DTime;
}




