/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */


#include <stdlib.h>
#include <signal.h>
#include "Signals.h"
#include "Log.h"

#include "setup.h"


int SigSegVInit(void);
void SigSegVDone(void);

void sigsegv(int sig, struct my_sigcontext_struct context);



// Signal structures
struct sigcontext_struct {
	unsigned short gs, __gsh;
	unsigned short fs, __fsh;
	unsigned short es, __esh;
	unsigned short ds, __dsh;
	unsigned long edi;
	unsigned long esi;
	unsigned long ebp;
	unsigned long esp;
	unsigned long ebx;
	unsigned long edx;
	unsigned long ecx;
	unsigned long eax;
	unsigned long trapno;
	unsigned long err;
	unsigned long eip;
	unsigned short cs, __csh;
	unsigned long eflags;
	unsigned long esp_at_signal;
	unsigned short ss, __ssh;
	struct _fpstate * fpstate;
	unsigned long oldmask;
	unsigned long cr2;
};
struct my_sigcontext_struct {
	unsigned long Dump[75];
	unsigned long adr;
};




void (*OldSigSegV)(int) = NULL;



int SigSegVInit(void)
{
#ifdef USEMOD_SIGNALS
#ifdef WINDOZE
								// Head !!!!!!!!!!!!!!!!!!!!
#ifndef __FreeBSD__
	OldSigSegV = signal(SIGSEGV,(void (*)(int))sigsegv); // signal handling for non-FreeBSD
#else
	OldSigSegV = signal(SIGBUS,sigsegv); // FreeBSD signal handling
#endif
	if (OldSigSegV == SIG_ERR)
	{
		OldSigSegV = NULL;
		logError(modMain, "Can't set SIGSEGV signal handler.");
		return 0;
	}
#endif
#endif
	return 1;
}


void SigSegVDone(void)
{
#ifdef USEMOD_SIGNALS
#ifdef WINDOZE
								// Head !!!!!!!!!!!!!!!!!!!!
	if (OldSigSegV != NULL)
	{
		void (*CurrentSigSegV)(int);
	#ifndef __FreeBSD__
		CurrentSigSegV = signal(SIGSEGV,OldSigSegV); // signal handling for non-FreeBSD
	#else
		CurrentSigSegV = signal(SIGBUS,OldSigSegV); // FreeBSD signal handling
	#endif
		if (CurrentSigSegV == SIG_ERR)
			logError(modMain, "Can't set default handler for SIGSEGV signal.");
		else if ((void*)CurrentSigSegV != (void*)sigsegv)
			logError(modMain, "SIGSEGV signal handler was changed during program run.");
	}
#endif
#endif
}

#ifdef WINDOZE
								// Head !!!!!!!!!!!!!!!!!!!!

#ifndef __FreeBSD__
void sigsegv(int sig, struct my_sigcontext_struct context)
{
	unsigned long adr = context.adr;
	throw ESigSegV(adr);
}
#else
void sigsegv(int sig, struct my_sigcontext_struct context) // FreeBSD version
{
	throw ESigSegV(context.cr2);
}
#endif

#endif

