/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

 
#include <string.h>
#include "TexLoad.h"
#include "Log.h"
#include "TgaPcxLoad.h"

#define WANT_STRLWR
#include "porting.h"



int TextureLoader::Open(char *FileName)
{
  #define MAX_EXT_LENGTH 3
  int i;
  char *c;
  char ext[MAX_EXT_LENGTH+1];

  if (ObjBusy) return 0;

  // set flags
  ObjBusy = true;

  // get file extension
  c = strrchr(FileName, '.');
  if (c != NULL)
  {
    ++c;
    i = 0;
    while (*c != 0)
    {
      ext[i] = *c;
      ++c;
      ++i;
      if (i >= MAX_EXT_LENGTH) break;
    }
    ext[i] = 0;
  }
  else
  	ext[0] = 0;

  // call loader
  strlwr(ext);
  if (strcmp(ext, "tga") == 0)
  {
  	if (!TgaInit(Info)) return 0;
    if (!TgaReadHeader(Info, FileName))
    { TgaDone(Info); return 0; }
  }
  else
  {
  	logError(modTextures, "Can't load texture \"%s\". Unsupported file format: \"%s\".", FileName, &ext);
    return 0;
  }

  return 1;
}


int TextureLoader::StartTextureReading(void *Buf, unsigned int Size)
{
  if (!TgaReadBody(Info, Buf)) return 0;

  return 1;
}


void TextureLoader::Close(void)
{
	if (ObjBusy)
	{
		TgaDone(Info);
		ObjBusy = false;
	}
}

