/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */


#ifndef _TexLoad_h_
#define _TexLoad_h_

#include <stdio.h>
#include "mygl.h"


typedef struct {
	bool HeaderLoaded;
	bool BodyLoaded;
	GLsizei Width;
	GLsizei Height;
	GLuint BPP;
	GLenum Format;
	FILE *F;
	void *IntData;
} TEXINFO;


class TextureLoader
{
private:
	TEXINFO Info;

	bool ObjBusy;

public:
	inline GLsizei TexWidth(void)  { return Info.Width; };
	inline GLsizei TexHeight(void)  { return Info.Height; };
	inline GLenum TexFormat(void)  { return Info.Format; };

	inline bool Busy(void)  { return ObjBusy; };

	int Open(char *FileName);
	inline bool IsHeaderLoaded(void)  { return Info.HeaderLoaded; };
	int StartTextureReading(void *Buf, unsigned int Size);
	bool IsTextureLoaded(void)  { return Info.BodyLoaded; };
	void Close(void);

	TextureLoader(void)  :ObjBusy(0)  {};
	~TextureLoader(void)  { Close(); };
};



#endif /* _TexLoad_h_ */
