/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

#ifndef _gui_h_
#define _gui_h_


#include "Log.h"


/* Tady bude cokoli program ma "vedet" o stavu GUI, nebo ruzna nastaveni, kterych
 * si gui bude vsimat
 */
typedef struct GuiInfo {
		int winWidth;
		int winHeight;
		int winWidth2;
		int winHeight2;

		int Terminated;

		int argc;
		char **argv;

} GuiInfo;

extern GuiInfo guiInfo;


int  guiInit(int argc, char *argv[]);
void guiDone(void);

void guiMainLoop(void);
void guiTerminateApp(void);
void guiForcedTerminate(void);

int guiCheckForGLErrors(logModule M, char *ErrorString);
inline int guiCheckForGLErrorsQ(void)  { return guiCheckForGLErrors(modUnknown, "Rendering error %s."); };

void guiRenderScene(void);
void guiAfterRendering(void);
void guiWindowReshape(int width, int height);
void guiIdle(void);


#endif /* ifdef _gui_h_ */

